c     Subroutines to set all arguments sent to the isf_writ functions to null.
c     Real and float variables are set to the common block parameter ISF_NULL,
c     this parameter is set in 'isf_head.h'.
c     Strings are set to a single space.
c     The write routines check for these values and use them to distinguish 
c     between zero and undefined arguments.

      subroutine nullify_data_type(data_type,subtype,data_format,
     +                                                    subformat)

      character data_type*(*), subtype*(*), data_format*(*)
      character subformat*(*)
      include 'isf_head.h'

      data_type   = " "
      subtype     = " "
      data_format = " "
      subformat   = " "

      return
      end

      subroutine nullify_event_id(evid,region)

      character evid*(*),region*(*)

      evid   = " "
      region = " "

      return
      end

      subroutine nullify_origin(yyyy,mm,dd,hh,mi,ss,msec,timfix,stime,
     + sdobs,lat,lon,epifix,smaj,smin,strike,depth,depfix,
     + sdepth,ndef,nsta,gap,mindist,maxdist,antype,loctype,
     + etype,author,origid)

      character author*(*), origid*(*), etype*(*)
      character*1 timfix, epifix, depfix, antype, loctype
      integer yyyy, mm, dd, hh, mi, ss, msec
      integer strike, ndef, nsta, gap
      real stime, sdobs, lat, lon, smaj, smin, depth, sdepth
      real mindist, maxdist
      include 'isf_head.h'

      yyyy   = ISF_NULL
      mm     = ISF_NULL
      dd     = ISF_NULL
      hh     = ISF_NULL
      mi     = ISF_NULL
      ss     = ISF_NULL
      msec   = ISF_NULL
      timfix = ' '
      stime  = ISF_NULL
      sdobs  = ISF_NULL
      lat    = ISF_NULL
      lon    = ISF_NULL
      epifix = ' '
      smaj   = ISF_NULL
      smin   = ISF_NULL
      strike = ISF_NULL
      depth  = ISF_NULL
      depfix = ' '
      sdepth = ISF_NULL
      ndef   = ISF_NULL
      nsta   = ISF_NULL
      gap    = ISF_NULL
      mindist = ISF_NULL
      maxdist = ISF_NULL
      antype = ' '
      loctype = ' '
      etype  = " "
      author = " "
      origid = " "

      return
      end

      subroutine nullify_origin_param(param,value,numparam)

      integer numparam
      character param(*)*(*),value(*)*(*)

      numparam = 0
      return
      end

      subroutine nullify_momten(scale_factor,scalar_moment,fclvd,
     + mrr,mtt,mpp,mrt,mtp,mpr,nsta1,nsta2,author,scalar_moment_unc,
     + fclvd_unc,mrr_unc,mtt_unc,mpp_unc,mrt_unc,mtp_unc,mpr_unc,
     + ncomp1,ncomp2,duration)

      character author*(*)
      integer scale_factor,nsta1,nsta2,ncomp1,ncomp2
      real scalar_moment,fclvd,mrr,mtt,mpp,mrt,mtp,mpr
      real scalar_moment_unc,fclvd_unc,mrr_unc,mtt_unc,mpp_unc
      real mrt_unc,mtp_unc,mpr_unc,duration
      include 'isf_head.h'

      scale_factor  = ISF_NULL
      scalar_moment = ISF_NULL
      fclvd         = ISF_NULL
      mrr           = ISF_NULL
      mtt           = ISF_NULL
      mpp           = ISF_NULL
      mrt           = ISF_NULL
      mtp           = ISF_NULL
      mpr           = ISF_NULL
      nsta1         = ISF_NULL
      nsta2         = ISF_NULL
      author = " "

      scalar_moment_unc = ISF_NULL
      fclvd_unc         = ISF_NULL
      mrr_unc           = ISF_NULL
      mtt_unc           = ISF_NULL
      mpp_unc           = ISF_NULL
      mrt_unc           = ISF_NULL
      mtp_unc           = ISF_NULL
      mpr_unc           = ISF_NULL
      ncomp1            = ISF_NULL
      ncomp2            = ISF_NULL
      duration          = ISF_NULL

      return
      end

      subroutine nullify_fault_plane (f_type,strike,dip,rake,np,ns,
     + f_plane,author)

      character f_plane*(*), f_type*(*), author*(*)
      integer np,ns
      real strike,dip,rake
      include 'isf_head.h'

      f_type = " "
      strike = ISF_NULL
      dip    = ISF_NULL
      rake   = ISF_NULL
      np     = ISF_NULL
      ns     = ISF_NULL
      f_plane = " "
      author  = " "

      return
      end

      subroutine nullify_axes(scale_factor,t_val,t_azim,t_pl,b_val,
     + b_azim,b_pl,p_val,p_azim,p_pl,author)

      character author*(*)
      integer scale_factor
      real t_val,t_azim,t_pl,b_val,b_azim,b_pl,p_val,p_azim,p_pl

      include 'isf_head.h'

      scale_factor = ISF_NULL
      t_val    = ISF_NULL
      t_azim   = ISF_NULL
      t_pl     = ISF_NULL
      b_val    = ISF_NULL
      b_azim   = ISF_NULL
      b_pl     = ISF_NULL
      p_val    = ISF_NULL
      p_azim   = ISF_NULL
      p_pl     = ISF_NULL
      author = " "

      return
      end

      subroutine 
     +nullify_axes_err(t_val_unc,t_azim_unc,t_pl_unc,b_val_unc,
     + b_azim_unc,b_pl_unc,p_val_unc,p_azim_unc,p_pl_unc,fclvd)

      real t_val_unc,t_azim_unc,t_pl_unc,b_val_unc,b_azim_unc,b_pl_unc
      real p_val_unc,p_azim_unc,p_pl_unc,fclvd

      include 'isf_head.h'

      t_val_unc  = ISF_NULL
      t_azim_unc = ISF_NULL
      t_pl_unc   = ISF_NULL
      b_val_unc  = ISF_NULL
      b_azim_unc = ISF_NULL
      b_pl_unc   = ISF_NULL
      p_val_unc  = ISF_NULL
      p_azim_unc = ISF_NULL
      p_pl_unc   = ISF_NULL
      fclvd      = ISF_NULL

      return
      end

      subroutine nullify_effects(heard,felt,damage,casualties,uplift,
     + subsidence,fault,tsunami,seiche,volcano,acoustic,gravity,
     + t_wave,liquification,geyser,landslide,sandblow,cracks,lights,
     + odours,loctype,lat,lon,dist,azim,country,postcode,net,
     + sta,intensity1,modifier,intensity2,scale,author)

      character author*(*),loctype*(*)
      character scale*(*),country*(*),postcode*(*),net*(*),sta*(*)
      character heard,felt,damage,casualties,uplift,subsidence
      character fault,tsunami,seiche,volcano
      character acoustic,gravity,t_wave,liquification,geyser
      character landslide,sandblow,cracks,lights,odours
      character modifier
      real lat,lon,dist,azim,intensity1,intensity2

      include 'isf_head.h'

      heard      = ' '
      felt       = ' '
      damage     = ' '
      casualties = ' '
      uplift     = ' '
      subsidence = ' '
      fault      = ' '
      tsunami    = ' '
      seiche     = ' '
      volcano    = ' '
      acoustic   = ' '
      gravity    = ' '
      t_wave     = ' '
      liquification = ' '
      geyser     = ' '
      landslide  = ' '
      sandblow   = ' '
      cracks     = ' '
      lights     = ' '
      odours     = ' '
      loctype    = " "
      lat   = ISF_NULL
      lon   = ISF_NULL
      dist  = ISF_NULL
      azim  = ISF_NULL
      country  = " "
      postcode = " "
      net = " "
      sta = " "
      intensity1 = ISF_NULL
      modifier = ' '
      intensity2 = ISF_NULL
      scale  = " "
      author = " "

      return
      end

      subroutine nullify_netmag(magtype,magind,mag,magerr,nsta,
     +                                              author,origid)

      character magtype*(*), author*(*), origid*(*)
      character magind
      real mag,magerr
      integer nsta

      include 'isf_head.h'

      magtype = " "
      magind = ' '
      mag    = ISF_NULL
      magerr = ISF_NULL
      nsta   = ISF_NULL
      author = " "
      origid = " "

      return
      end

      subroutine nullify_netmag_sta(sta,n)

      integer n
      character sta(*)*(*)

      n = 0
      return
      end

      subroutine nullify_netmag_basis(param,value)

      character param*(*), value*(*)

      param = " "
      value = " "

      return
      end

      subroutine nullify_phase(sta,dist,esaz,phase,hh,mi,ss,msec,
     + timeres,azim,azimres,slow,slowres,timedef,azimdef,slowdef,
     + snr,amp,per,picktype,sp_fm,detchar,magtype,magind,mag,arrid)

      character sta*(*),arrid*(*),phase*(*),magtype*(*)
      character timedef,azimdef,slowdef,sp_fm,detchar,magind,picktype
      real dist,esaz,timeres,azim,azimres,slow,slowres,snr,amp,per,mag
      integer hh,mi,ss,msec

      include 'isf_head.h'

      sta     = " "
      dist    = ISF_NULL
      esaz    = ISF_NULL
      phase   = " "
      hh      = ISF_NULL
      mi      = ISF_NULL
      ss      = ISF_NULL
      msec    = ISF_NULL
      timeres = ISF_NULL
      azim    = ISF_NULL
      azimres = ISF_NULL
      slow    = ISF_NULL
      slowres = ISF_NULL
      timedef = ' '
      azimdef = ' '
      slowdef = ' '
      snr     = ISF_NULL
      amp     = ISF_NULL
      per     = ISF_NULL
      picktype = ' '
      sp_fm    = ' '
      detchar  = ' '
      magtype  = " "
      magind   = ' '
      mag      = ISF_NULL
      arrid    = " "

      return
      end

      subroutine nullify_phase_measure(param,value,numparam)

      integer numparam
      character param(*)*(*),value(*)*(*)

      numparam = 0

      return
      end

      subroutine nullify_phase_origid(origid)

      character origid*(*)

      origid = " "

      return
      end

      subroutine nullify_phase_info(net,chan,filter,filter_min,
     + filter_max,phase,yyyy,mm,dd,time_unc,time_weight,
     + azim_unc,azim_weight,slow_unc,slow_weight,amp_unc,
     + per_unc,mag_unc,author,arrid)

      character net*(*),chan*(*),author*(*),arrid*(*),phase*(*)
      character filter
      real filter_min,filter_max,time_unc,time_weight,azim_unc
      real azim_weight
      real slow_unc,slow_weight,amp_unc,per_unc,mag_unc
      integer yyyy,mm,dd

      include 'isf_head.h'

      net    = " "
      chan   = " "
      filter = ' '
      filter_min  = ISF_NULL
      filter_max  = ISF_NULL
      phase  = " "
      yyyy        = ISF_NULL
      mm          = ISF_NULL
      dd          = ISF_NULL
      time_unc    = ISF_NULL
      time_weight = ISF_NULL
      azim_unc    = ISF_NULL
      azim_weight = ISF_NULL
      slow_unc    = ISF_NULL
      slow_weight = ISF_NULL
      amp_unc     = ISF_NULL
      per_unc     = ISF_NULL
      mag_unc     = ISF_NULL
      author = " "
      arrid  = " "

      return
      end

      subroutine nullify_phase_min(timeoffset,azoffset,
     +                        slowoffset,ampoffset,peroffset,magoffset)

      real timeoffset,azoffset,slowoffset,ampoffset,peroffset,magoffset

      include 'isf_head.h'

      timeoffset = ISF_NULL
      azoffset   = ISF_NULL
      slowoffset = ISF_NULL
      ampoffset  = ISF_NULL
      peroffset  = ISF_NULL
      magoffset  = ISF_NULL

      return
      end

      subroutine nullify_phase_max(timeoffset,azoffset,
     +                        slowoffset,ampoffset,peroffset,magoffset)

      real timeoffset,azoffset,slowoffset,ampoffset,peroffset,magoffset

      include 'isf_head.h'

      timeoffset = ISF_NULL
      azoffset   = ISF_NULL
      slowoffset = ISF_NULL
      ampoffset  = ISF_NULL
      peroffset  = ISF_NULL
      magoffset  = ISF_NULL

      return
      end

      subroutine nullify_phase_correc(timecorr,azcorr,
     +                        slowcorr,ampcorr,percorr,magcorr)

      real timecorr,azcorr,slowcorr,ampcorr,percorr,magcorr

      include 'isf_head.h'

      timecorr = ISF_NULL
      azcorr   = ISF_NULL
      slowcorr = ISF_NULL
      ampcorr  = ISF_NULL
      percorr  = ISF_NULL
      magcorr  = ISF_NULL

      return
      end

      subroutine nullify_phase_original(chan,sta,yyyy,mm,
     + dd,hh,mi,ss,msec,azim,slow,amp,per,mag)

      character sta*(*),chan*(*)
      real azim,slow,amp,per,mag
      integer yyyy,mm,dd,hh,mi,ss,msec

      include 'isf_head.h'

      chan  = " "
      yyyy  = ISF_NULL
      mm    = ISF_NULL
      dd    = ISF_NULL
      hh    = ISF_NULL
      mi    = ISF_NULL
      ss    = ISF_NULL
      msec  = ISF_NULL
      azim  = ISF_NULL
      slow  = ISF_NULL
      amp   = ISF_NULL
      per   = ISF_NULL
      mag   = ISF_NULL

      return
      end

      subroutine nullify_comment(comment)

      character comment*(*)

      comment = " "

      return
      end

      subroutine nullify_group(net,sta,chan,auxid,yyyy,mm,dd,
     + hh,mi,ss,msec,phase,azim,slow,snr,amp,per,picktype,sp_fm,
     + detchar,groupid,conflict,author,arrid)

      character net*(*),sta*(*),chan*(*),auxid*(*),phase*(*)
      character groupid*(*),author*(*),arrid*(*)
      character sp_fm,detchar,picktype
      real azim,slow,snr,amp,per
      integer yyyy,mm,dd,hh,mi,ss,msec,conflict

      include 'isf_head.h'

      net     = " "
      sta     = " "
      chan    = " "
      auxid   = " "
      yyyy    = ISF_NULL
      mm      = ISF_NULL
      dd      = ISF_NULL
      hh      = ISF_NULL
      mi      = ISF_NULL
      ss      = ISF_NULL
      msec    = ISF_NULL
      phase   = " "
      azim    = ISF_NULL
      slow    = ISF_NULL
      snr     = ISF_NULL
      amp     = ISF_NULL
      per     = ISF_NULL
      picktype = ' '
      sp_fm    = ' '
      detchar  = ' '
      groupid  = " "
      conflict = ISF_NULL
      author   = " "
      arrid    = " "

      return
      end
